
<nz-table 
    #memberTable
    nzSize="small"
    [nzFooter]="footer"
    [nzData]="_data.list"
    [nzScroll]="{ y: '22rem' }"
    [nzFrontPagination]="true"
    [nzShowPagination]="true">
    <thead>
        <tr>
            <th 
                nzCustomFilter
                nzWidth="200px">
                Discord
                <i
                    class="ant-table-filter-icon"
                    nz-th-extra
                    nz-icon
                    nz-dropdown
                    #dropdown="nzDropdown"
                    nzType="search"
                    [nzDropdownMenu]="menu"
                    [class.ant-table-filter-open]="dropdown.nzVisible"
                    nzTrigger="click"
                    nzPlacement="bottomRight"
                    [nzClickHide]="false"
                    nzTableFilter>
                </i>
            </th>
            <th>
                Ranks
            </th>
            <th
                nzWidth="75px">
                Roles
            </th>
            <th nzWidth="150px">Actions</th>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let member of memberTable.data">
            <td>
                <span 
                    nz-tooltip 
                    nzTooltipTitle="{{ member.discordInfo.id }}">
                    {{ getShortUsername(member) }}#{{ member.discordInfo.tag }}
                </span>
            </td>
            <td>
                <nz-tag
                    *ngIf="member.ranks"
                    class="h-full text-center"
                    nz-popover
                    nzPopoverTrigger="click"
                    nzPopoverPlacement="right"
                    [nzPopoverContent]="gameTags">
                    <span>+{{ prepTags(member.ranks).length }}</span>
                    <ng-template #gameTags>
                        <div fxLayout="column">
                            <nz-tag 
                                *ngFor="let game of prepTags(member.ranks); let gameIndex = index; let gameLength = count"
                                [ngClass]="{ 'mb-4' : ( (gameIndex + 1) == gameLength ) ? false : true }">
                                <div 
                                    *ngIf="!member.ranks[game]"
                                    class="w-full h-full text-center">
                                    <span>{{ capitalize(addSpaces(game)) }}</span>
                                </div>
                                <div 
                                    *ngIf="member.ranks[game]"
                                    class="w-full h-full text-center"
                                    nz-popover  
                                    nzPopoverTrigger="hover"
                                    nzPopoverPlacement="right"
                                    [nzPopoverContent]="groupTags">
                                    <span>{{ capitalize(addSpaces(game)) }}</span>
                                </div>
                                
                                <ng-template #groupTags>
                                    <div fxLayout="column">
                                        <nz-tag 
                                            *ngFor="let group of prepTags(member.ranks[game]); let groupIndex = index; let groupLength = count"
                                            [ngClass]="{ 'mb-4' : ( (groupIndex + 1) == groupLength ) ? false : true }">
                                            <div 
                                                *ngIf="!member.ranks[game][group]"
                                                class="w-full h-full text-center">
                                                <span>{{ capitalize(addSpaces(group)) }}</span>
                                            </div>
                                            <div 
                                                *ngIf="member.ranks[game][group]"
                                                class="w-full h-full text-center"
                                                nz-popover  
                                                nzPopoverTrigger="hover"
                                                nzPopoverPlacement="right"
                                                [nzPopoverContent]="roleTags">
                                                <span>{{ capitalize(addSpaces(group)) }}</span>
                                            </div>
                                            <ng-template #roleTags>
                                                <div fxLayout="column">
                                                    <nz-tag 
                                                        *ngFor="let role of member.ranks[game][group]; let roleIndex = index; let roleLength = count"
                                                        class="w-full h-full text-center"
                                                        [ngClass]="{ 'mb-4' : ( (roleIndex + 1) == roleLength) ? false : true }">
                                                        <span>{{ capitalize(addSpaces(role)) }}</span>
                                                    </nz-tag>
                                                </div>
                                            </ng-template>
                                        </nz-tag>
                                    </div>
                                </ng-template>
                                
                            </nz-tag>
                        </div>
                    </ng-template>
                </nz-tag>
                <nz-tag
                    *ngIf="!member.ranks"
                    class="h-full text-center">
                    <span>None</span>
                </nz-tag>
            </td>
            <td>
                <nz-tag
                    *ngIf="member.roles"
                    class="h-full text-center"
                    nz-popover
                    nzPopoverTrigger="click"
                    nzPopoverPlacement="right"
                    [nzPopoverContent]="gameTags">
                    <span>+{{ prepTags(member.roles).length }}</span>
                    <ng-template #gameTags>
                        <div fxLayout="column">
                            <nz-tag 
                                *ngFor="let game of prepTags(member.roles); let gameIndex = index; let gameLength = count"
                                [ngClass]="{ 'mb-4' : ( (gameIndex + 1) == gameLength ) ? false : true }">
                                <div 
                                    *ngIf="!member.ranks[game]"
                                    class="w-full h-full text-center">
                                    <span>{{ capitalize(addSpaces(game)) }}</span>
                                </div>
                                <div 
                                    *ngIf="member.roles[game]"
                                    class="w-full h-full text-center"
                                    nz-popover  
                                    nzPopoverTrigger="hover"
                                    nzPopoverPlacement="right"
                                    [nzPopoverContent]="groupTags">
                                    <span>{{ capitalize(addSpaces(game)) }}</span>
                                </div>
                                
                                <ng-template #groupTags>
                                    <div fxLayout="column">
                                        <nz-tag 
                                            *ngFor="let group of prepTags(member.roles[game]); let groupIndex = index; let groupLength = count"
                                            [ngClass]="{ 'mb-4' : ( (groupIndex + 1) == groupLength ) ? false : true }">
                                            <div 
                                                *ngIf="!member.roles[game][group]"
                                                class="w-full h-full text-center">
                                                <span>{{ capitalize(addSpaces(group)) }}</span>
                                            </div>
                                            <div 
                                                *ngIf="member.roles[game][group]"
                                                class="w-full h-full text-center"
                                                nz-popover  
                                                nzPopoverTrigger="hover"
                                                nzPopoverPlacement="right"
                                                [nzPopoverContent]="roleTags">
                                                <span>{{ capitalize(addSpaces(group)) }}</span>
                                            </div>
                                            <ng-template #roleTags>
                                                <div fxLayout="column">
                                                    <nz-tag 
                                                        *ngFor="let role of member.roles[game][group]; let roleIndex = index; let roleLength = count"
                                                        class="w-full h-full text-center"
                                                        [ngClass]="{ 'mb-4' : ( (roleIndex + 1) == roleLength) ? false : true }">
                                                        <span>{{ capitalize(addSpaces(role)) }}</span>
                                                    </nz-tag>
                                                </div>
                                            </ng-template>
                                        </nz-tag>
                                    </div>
                                </ng-template>
                                
                            </nz-tag>
                        </div>
                    </ng-template>
                </nz-tag>
                <nz-tag
                    *ngIf="!member.roles"
                    class="h-full text-center">
                    <span>None</span>
                </nz-tag>
            </td>
            <td>
                <a 
                    class="action-buttons"
                    nz-tooltip 
                    nzTooltipTitle="View"
                    (click)="view(member)">
                    <i 
                        nz-icon 
                        nzType="mdi:account-search">
                    </i> 
                </a>
                <nz-divider nzType="vertical"></nz-divider>
                <a 
                    class="action-buttons"
                    nz-tooltip 
                    nzTooltipTitle="Edit"
                    (click)="update(member)">
                    <i 
                        nz-icon 
                        nzType="mdi:account-edit">
                    </i> 
                </a>
                <nz-divider nzType="vertical"></nz-divider>
                <a 
                    class="action-buttons"
                    nz-popconfirm
                    nzPopconfirmPlacement="bottom"
                    nzPopconfirmTitle="Are you sure you want to delete {{ member.discordInfo.username }}?"
                    nzOkText="Delete"
                    nzCancelText="Cancel"
                    (nzOnConfirm)="onConfirm(member)"
                    (nzOnCancel)="onCancel(member)"
                    nz-tooltip 
                    nzTooltipTitle="Delete">
                    <i 
                        nz-icon 
                        nzType="mdi:account-remove">
                    </i> 
                </a>
            </td>
        </tr>
    </tbody>
</nz-table>

<!-- Dropdown Sort Discord -->
<nz-dropdown-menu #menu="nzDropdownMenu">
    <div class="p-1" fxLayout="column">
        <input 
            nz-input 
            type="text" 
            placeholder="Search name" 
            [(ngModel)]="searchValue" 
            fxFlex/>
        <div 
            class="pt-1"
            fxLayout="row"
            fxLayoutAlign="space-between center">
            <button 
                nz-button 
                nzSize="small" 
                nzType="primary" 
                (click)="searchByUsername()"
                fxFlex="49">
                Search
            </button>
            <button 
                nz-button 
                nzSize="small" 
                (click)="reset()"
                fxFlex="49">
                Reset
            </button>
        </div>
    </div>
</nz-dropdown-menu>

<!-- Table footer -->
<ng-template #footer>
    <div
        class="px-4"
        fxLayout="row"
        fxLayoutAlign="space-between center">
        <a 
            class="action-buttons"
            nz-tooltip 
            nzTooltipTitle="Add"
            nzTooltipPlacement="right"
            (click)="insert()">
            <i 
                nz-icon 
                nzType="mdi:account-plus">
            </i> 
        </a>
        <a 
            class="action-buttons"
            nz-tooltip 
            nzTooltipTitle="Refresh"
            nzTooltipPlacement="left"
            (click)="refresh()">
            <i 
                nz-icon 
                nzType="mdi:refresh">
            </i> 
        </a>
    </div>
</ng-template>

<!-- Modal (Insert/Update) -->
<app-modal
    *ngIf="_data"
    [setData]="modal"
    (isVisibleChange)="isModalVisibleChange($event)">
</app-modal>

<!-- Drawer (View) -->
<app-drawer-view
    *ngIf="_data"
    [init]="drawer"
    (isVisibleChange)="isDrawerVisibleChange($event)">
</app-drawer-view>
